-- ========================================================================== --
-- SISTEMA         : COMISSARIA
-- DATA DA CRIAO : INCIO - 10/01/98
-- PROGRAMADOR     : LEANDRO
-- OBJETIVOS       : GRAVA TABELA DE FREQUNCIA DE CICLOS DIRIOS
-- ========================================================================== --

CREATE OR REPLACE PROCEDURE GRAVACICLODIA
(P_DATAINI    DATE,
 P_DATAFIM    DATE,
 P_INTERVALO  NUMERIC,
 P_NUMECICLOS NUMERIC,
 P_COMPANHIA  CHAR,
 P_CDFILIAL   FILIAL.CDFILIAL%TYPE,
 P_CICLO      CHAR,
 P_VOO        CHAR,
 P_TRECHO     CHAR,
 P_SERVICO    CHAR,
 P_CLASSE     CHAR,
 P_TIPOGRAVA  CHAR,
 P_IDOPERACAO NUMERIC) IS

DTDATA DATE;
INCONT NUMERIC(3);

BEGIN

IF P_IDOPERACAO = 1 THEN

   DTDATA := P_DATAINI;
   INCONT := 0;

   WHILE (DTDATA <= P_DATAFIM) LOOP

      IF (P_TIPOGRAVA = '1') THEN
         DELETE FROM FRCICLOCIA
         WHERE
            (CDCIA = P_COMPANHIA) AND
            (CDFILIAL = P_CDFILIAL) AND
            (DTCICLOCIA = DTDATA);

         INSERT INTO FRCICLOCIA
            (CDFILIAL,CDCIA,DTCICLOCIA,CDCICLO)
         VALUES
            (P_CDFILIAL,P_COMPANHIA,DTDATA,P_CICLO);
      END IF;

      IF (P_TIPOGRAVA = '2') THEN
         DELETE FROM FRCICLOVOO
         WHERE
            (CDCIA = P_COMPANHIA) AND
            (CDFILIAL = P_CDFILIAL) AND
            (NRVOO = P_VOO) AND
            (CDTRECHO = P_TRECHO) AND
            (DTCICLOVOO = DTDATA);

         INSERT INTO FRCICLOVOO
            (CDCIA,CDFILIAL,NRVOO,CDTRECHO,DTCICLOVOO,CDCICLO)
         VALUES
            (P_COMPANHIA,P_CDFILIAL,P_VOO,P_TRECHO,DTDATA,P_CICLO);
      END IF;

      IF (P_TIPOGRAVA = '3') THEN
         DELETE FROM FRCICLOSER
         WHERE
            (CDCIA = P_COMPANHIA) AND
            (CDFILIAL = P_CDFILIAL) AND
            (NRVOO = P_VOO) AND
            (CDSERVICO = P_SERVICO) AND
            (DTCICLOSER = DTDATA);

         INSERT INTO FRCICLOSER
            (CDCIA,CDFILIAL,NRVOO,CDSERVICO,DTCICLOSER)
         VALUES
            (P_COMPANHIA,P_CDFILIAL,P_VOO,P_SERVICO,DTDATA);
      END IF;

      IF (P_TIPOGRAVA = '4') THEN
         DELETE FROM FRCICLOVCLA
         WHERE
            (CDCIA = P_COMPANHIA) AND
            (CDFILIAL = P_CDFILIAL) AND
            (NRVOO = P_VOO) AND
            (CDTRECHO = P_TRECHO) AND
            (CDCLASSE = P_CLASSE) AND
            (DTCICLOVCLA = DTDATA);

         INSERT INTO FRCICLOVCLA
            (CDCIA,CDFILIAL,NRVOO,CDTRECHO,CDCLASSE,DTCICLOVCLA,CDCICLO)
         VALUES
            (P_COMPANHIA,P_CDFILIAL,P_VOO,P_TRECHO,P_CLASSE,DTDATA,P_CICLO);
      END IF;

      INCONT := INCONT + 1;
      IF (INCONT = P_INTERVALO) THEN
         INCONT := 0;
         DTDATA := DTDATA + ((P_NUMECICLOS - 1) * P_INTERVALO);
      END IF;
      DTDATA := DTDATA + 1;
   END LOOP;

ELSIF P_IDOPERACAO = 2 THEN

      IF (P_TIPOGRAVA = '1') THEN
         DELETE FROM FRCICLOCIA
         WHERE
            (CDCIA = P_COMPANHIA) AND
            (CDFILIAL = P_CDFILIAL) AND
            (CDCICLO = P_CICLO) AND
            (DTCICLOCIA BETWEEN P_DATAINI AND P_DATAFIM);
      END IF;

      IF (P_TIPOGRAVA = '2') THEN
         DELETE FROM FRCICLOVOO
         WHERE
            (CDCIA = P_COMPANHIA) AND
            (CDFILIAL = P_CDFILIAL) AND
            (NRVOO = P_VOO) AND
            (CDTRECHO = P_TRECHO) AND
            (CDCICLO = P_CICLO) AND
            (DTCICLOVOO BETWEEN P_DATAINI AND P_DATAFIM);
      END IF;

      IF (P_TIPOGRAVA = '3') THEN
         DELETE FROM FRCICLOSER
         WHERE
            (CDCIA = P_COMPANHIA) AND
            (CDFILIAL = P_CDFILIAL) AND
            (NRVOO = P_VOO) AND
            (CDSERVICO = P_SERVICO) AND
            (DTCICLOSER BETWEEN P_DATAINI AND P_DATAFIM);
      END IF;

      IF (P_TIPOGRAVA = '4') THEN
         DELETE FROM FRCICLOVCLA
         WHERE
            (CDCIA = P_COMPANHIA) AND
            (CDFILIAL = P_CDFILIAL) AND
            (NRVOO = P_VOO) AND
            (CDTRECHO = P_TRECHO) AND
            (CDCLASSE = P_CLASSE) AND
            (CDCICLO = P_CICLO) AND
            (DTCICLOVCLA BETWEEN P_DATAINI AND P_DATAFIM);
      END IF;

END IF;
END;
/

ALTER PROCEDURE GRAVACICLODIA COMPILE
/
