function PreferenceManager (SynchronizableStorageEngineFactory, fallbackStorageStrategy, localStorageEngine, requestDataSourceEngine, Query, ScreenService, ZHPromise, ZhUtil, RepositoryFactory) {

	var PREFERENCE_MANAGER_STORAGE = "/zeedhiFramework#zhPreferences";
	ZhUtil.registerDataSource(PREFERENCE_MANAGER_STORAGE);
	var repository = RepositoryFactory.factory(PREFERENCE_MANAGER_STORAGE, "LOCAL");
	var storageStrategy;

	this.modifyStorageStrategy = function(primaryStrategy, secondaryStrategy, fallbackStrategy, alwaysSync, secondaryRequired) {
		storageStrategy = SynchronizableStorageEngineFactory.factory(primaryStrategy, secondaryStrategy, fallbackStrategy, alwaysSync, secondaryRequired);
	};

	this.storePreference = function(name, preferences) {
		if(name && preferences) {
			preferences.name = name;
			return repository.save(preferences);
		} else {
			return ZHPromise.reject({ err: ScreenService.i18n("Invalid arguments") });
		}
	};

	this.load = function(name) {
		if(name){
			var filter = Query.build().where("name").equals(name);
			return repository.find(filter).then(function(data){
				return Util.isArray(data) ? data[0] : undefined;
			});
		} else {
			return ZHPromise.reject({ err: ScreenService.i18n("Invalid arguments") });
		}
	};

	this.sync = function(callback, filters) {
		return storageStrategy.sync(PREFERENCE_MANAGER_STORAGE, callback, filters);
	};

	this.modifyStorageStrategy(localStorageEngine, requestDataSourceEngine, fallbackStorageStrategy);

}